/*
** RopGadget - Release v2.3
** Jonathan Salwan - http://shell-storm.org - http://twitter.com/shell_storm
** 2011-07-11
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
*/

#ifndef	 ROPgadget_H
#define	 ROPgadget_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <elf.h>

/* colors */
#define BLUE        "\033[94m"
#define GREEN       "\033[92m"
#define YELLOW      "\033[93m"
#define RED         "\033[91m"
#define ENDC        "\033[0m"

#define MAGIC_ELF         "\x7F\x45\x4C\x46"
#define NB_GADGET_LINUX   60
#define NB_GADGET_BSD     63
#define TRUE              0
#define FALSE             1

Elf32_Ehdr          *pElf_Header;
Elf32_Phdr          *pElf32_Phdr;
Elf32_Shdr          *pElf32_Shdr;
Elf32_Shdr          *pElf32_HeaderSection;
Elf32_Shdr          *pElf32_StringSection;
void                *pMapElf;

/* gadgets series */
typedef struct g_asm
{
  char *instruction;
  char *value;
} s_asm;

/* Chained list for map phdr with exec bit */
typedef struct s_maps_exec
{
  Elf32_Addr 		addr_start;
  Elf32_Addr 		addr_end;
  struct s_maps_exec 	*next;
} t_maps_exec;

/* core */
char           	*get_flags(Elf32_Word);
char           	*get_seg(Elf32_Word);
void           	syntax(char *);
void           	display_version(void);
void           	display_data(unsigned char *, unsigned int);
void           	search_gadgets(unsigned char *, unsigned int);
t_maps_exec   	*display_info_header(void);
unsigned char  	*save_bin_data(char *, unsigned int);
int            	check_elf_format(unsigned char *);
int            	check_arch_supported(void);
void           	no_elf_format(void);
void           	no_arch_supported(void);
void           	how_many_found(int *, int);
int 		check_exec_maps(t_maps_exec *, Elf32_Addr);

/* linux/x86-32bits */
void gadget_linux8632(unsigned char *, unsigned int, int *, Elf32_Addr, int, t_maps_exec *);
void linux8632(unsigned char *, unsigned int, t_maps_exec *);

/* BSD/x86-32bits */
void gadget_bsd8632(unsigned char *, unsigned int, int *, Elf32_Addr, int, t_maps_exec *);
void bsd8632(unsigned char *, unsigned int, t_maps_exec *);

#endif

