/*
** RopGadget - Release v2.3
** Jonathan Salwan - http://shell-storm.org - http://twitter.com/shell_storm
** 2011-07-11
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
*/

#include "ropgadget.h"

void search_gadgets(unsigned char *data, unsigned int size_data)
{
  t_maps_exec *maps_exec;

  if (check_elf_format(data) == -1)
    no_elf_format();
  if (check_arch_supported() == -1)
    no_arch_supported();

  maps_exec = display_info_header();
  fprintf(stdout, "%sGadgets informations\n", YELLOW);
  fprintf(stdout, "============================================================%s\n", ENDC);

  /* Linux/x86-32bits */
  if (pElf_Header->e_ident[EI_CLASS] == ELFCLASS32 && pElf_Header->e_ident[EI_OSABI] == ELFOSABI_NONE && pElf_Header->e_machine == EM_386)
    linux8632(data, size_data, maps_exec);
  /* BSD/x86-32bits */
  else if (pElf_Header->e_ident[EI_CLASS] == ELFCLASS32 && pElf_Header->e_ident[EI_OSABI] == ELFOSABI_FREEBSD && pElf_Header->e_machine == EM_386)
    bsd8632(data, size_data, maps_exec);

}

void bsd8632(unsigned char *data, unsigned int size_data, t_maps_exec *maps_exec)
{
  unsigned int cpt = 0;
  int tab[NB_GADGET_BSD + 1] = {0};
  int i = 0;

    while(cpt < size_data)
    {
      i = 0;
      while (i <= NB_GADGET_BSD)
        {
          if (tab[i] != 1)
            gadget_bsd8632(data, cpt, tab, (pElf32_Phdr->p_vaddr - pElf32_Phdr->p_offset), i, maps_exec);
          i++;
        }
      cpt++;
      data++;
    }
  how_many_found(tab, NB_GADGET_BSD);
}

void linux8632(unsigned char *data, unsigned int size_data, t_maps_exec *maps_exec)
{
  unsigned int cpt = 0;
  int tab[NB_GADGET_LINUX + 1] = {0};
  int i = 0;

    while(cpt < size_data)
    {
      i = 0;
      while (i <= NB_GADGET_LINUX)
        {
          if (tab[i] != 1)
            gadget_linux8632(data, cpt, tab, (pElf32_Phdr->p_vaddr - pElf32_Phdr->p_offset), i, maps_exec);
          i++;
        }
      cpt++;
      data++;
    }
  how_many_found(tab, NB_GADGET_LINUX);
}
